use test
go
if object_id('SimpleTable') is not null	
	drop table SimpleTable
create table SimpleTable(id int, text1 varchar(8000))
go
insert into SimpleTable 
	values	(100, replicate('a',2800)),
			(200, replicate('b',2800)),
			(300, replicate('c',2800)),
			(400, replicate('d',2800))
--select * from SimpleTable
--4 records inserted. it needs 2 data pages
go
---where are records located?
select * 
from SimpleTable a
	cross apply master.sys.fn_PhysLocCracker(%%physloc%%) b
go
---update
exec xp_cmdshell N'del c:\temp\locktest00*.*' ,no_output
ALTER EVENT SESSION locks ON SERVER STATE = START
go
begin transaction
update SimpleTable set text1 = replicate('e',2800) where id = 300
rollback
go
ALTER EVENT SESSION locks ON SERVER STATE = STOP
go
exec ShowEvents
go

--delete
exec xp_cmdshell N'del c:\temp\locktest00*.*' ,no_output
ALTER EVENT SESSION locks ON SERVER STATE = START
go
begin transaction
delete SimpleTable where id = 300
rollback
go
ALTER EVENT SESSION locks ON SERVER STATE = STOP
exec ShowEvents
go


---insert
exec ShowPages 
go
exec xp_cmdshell N'del c:\temp\locktest00*.*' ,no_output
ALTER EVENT SESSION locks ON SERVER STATE = START
go
begin transaction
insert into SimpleTable values(500, replicate('e',2800))
insert into SimpleTable values(600, replicate('f',2800))
rollback
go
ALTER EVENT SESSION locks ON SERVER STATE = STOP
exec ShowEvents
exec ShowPages  -- the page allocated is not released!
go 
/*
Formatting data page, 
	- U lock at extent level
	- X lock at page level
insertion may cause blocking at both extent and page level although it's transient
*/

--delete
-- I wonder if that applies to deletion as well
exec ShowPages

select * 
from SimpleTable a
	cross apply master.sys.fn_PhysLocCracker(%%physloc%%) b


exec xp_cmdshell N'del c:\temp\locktest00*.*' ,no_output
ALTER EVENT SESSION locks ON SERVER STATE = START
go
begin transaction
delete SimpleTable where id in (300, 400)
commit
go
ALTER EVENT SESSION locks ON SERVER STATE = STOP
exec ShowEvents 

-- intersting enough, even invisible record in page 172 is searched
exec ShowPages
go



go
----index scenario
if object_id('SimpleTable') is not null	
	drop table SimpleTable
create table SimpleTable(id int , text1 varchar(8000), constraint __PK__ primary key clustered(id))
go
insert into SimpleTable values(100, replicate('a',2800)),(200, replicate('b',2800)),(300, replicate('c',2800)),(400, replicate('d',2800))

---update
exec ShowPages 
exec xp_cmdshell N'del c:\temp\locktest00*.*' ,no_output
ALTER EVENT SESSION locks ON SERVER STATE = START
go
begin transaction
update SimpleTable set text1 = replicate('e',2800) where id = 300
rollback
go
ALTER EVENT SESSION locks ON SERVER STATE = STOP
go
exec ShowEvents
exec ShowPages 
go

--(id=300)dbo.SimpleTable.__PK__(id)-(9f502deadad2)/72057594039042048

select OBJECT_NAME(object_id), * 
from sys.partitions p
where p.partition_id = 72057594039042048

select * 
from SimpleTable with (index=[__PK__])
where %%lockres%% = '(9f502deadad2)'


select %%lockres%%, b.*, a.*  
from SimpleTable a with (index=[__PK__])
	cross apply master.sys.fn_PhysLocCracker(%%physloc%%) b


--delete
exec ShowPages 
exec xp_cmdshell N'del c:\temp\locktest00*.*' ,no_output
ALTER EVENT SESSION locks ON SERVER STATE = START
go
begin transaction
delete SimpleTable where id in( 300, 400)
commit
go
ALTER EVENT SESSION locks ON SERVER STATE = STOP
exec ShowEvents
exec ShowPages 
go

---insert
if object_id('SimpleTable') is not null	
	drop table SimpleTable
create table SimpleTable(id int , text1 varchar(8000), constraint __PK__ primary key clustered(id))
go
insert into SimpleTable values(100, replicate('a',2800)),(200, replicate('b',2800)),(300, replicate('c',2800)),(400, replicate('d',2800))

go
exec ShowPages  --279, 280
go
checkpoint
go
exec xp_cmdshell N'del c:\temp\locktest00*.*' ,no_output
ALTER EVENT SESSION locks ON SERVER STATE = START
go
begin transaction
insert into SimpleTable values(5001, replicate('e',2800))
insert into SimpleTable values(5002, replicate('f',2800))
commit
go
ALTER EVENT SESSION locks ON SERVER STATE = STOP
exec ShowEvents
exec ShowPages  
